Package: einsum
Type: Package
Title: Einstein Summation
Version: 0.1.2
Authors@R: person("Constantin", "Ahlmann-Eltze", email = "artjom31415@googlemail.com", 
               role = c("aut", "cre"), comment = c(ORCID = "0000-0002-3762-068X"))
Description: The summation notation suggested by Einstein (1916) <doi:10.1002/andp.19163540702> is a 
  concise mathematical notation that implicitly sums over repeated indices of n-dimensional arrays. Many ordinary
  matrix operations (e.g. transpose, matrix multiplication, scalar product, 'diag()', trace etc.)
  can be written using Einstein notation. The notation is particularly convenient for 
  expressing operations on arrays with more than two dimensions because the 
  respective operators ('tensor products') might not have a standardized name.
License: MIT + file LICENSE
Encoding: UTF-8
Suggests: testthat, covr
RdMacros: mathjaxr
RoxygenNote: 7.2.3
LinkingTo: Rcpp
Imports: Rcpp, glue, mathjaxr
URL: https://const-ae.github.io/einsum/
BugReports: https://github.com/const-ae/einsum/issues
NeedsCompilation: yes
Packaged: 2023-08-28 14:17:21 UTC; ahlmanne
Author: Constantin Ahlmann-Eltze [aut, cre]
    (<https://orcid.org/0000-0002-3762-068X>)
Maintainer: Constantin Ahlmann-Eltze <artjom31415@googlemail.com>
Repository: CRAN
Date/Publication: 2023-08-28 14:40:03 UTC
Built: R 4.3.3; aarch64-apple-darwin20; 2025-01-24 07:03:52 UTC; unix
Archs: einsum.so.dSYM

Package: einsum
Type: Package
Title: Einstein Summation
Version: 0.2.0
Authors@R: c(
    person("Constantin", "Ahlmann-Eltze", email = "artjom31415@googlemail.com",
               role = c("aut", "cre"), comment = c(ORCID = "0000-0002-3762-068X")),
    person("Koki", "Tsuyuzaki", email = "k.t.the-answer@hotmail.co.jp",
               role = "aut", comment = c(ORCID = "0000-0003-3797-2148"))
    )
Description: The summation notation suggested by Einstein (1916) <doi:10.1002/andp.19163540702> is a 
  concise mathematical notation that implicitly sums over repeated indices of n-dimensional arrays. Many ordinary
  matrix operations (e.g. transpose, matrix multiplication, scalar product, 'diag()', trace etc.)
  can be written using Einstein notation. The notation is particularly convenient for 
  expressing operations on arrays with more than two dimensions because the 
  respective operators ('tensor products') might not have a standardized name.
License: MIT + file LICENSE
Encoding: UTF-8
Suggests: testthat, covr
RdMacros: mathjaxr
RoxygenNote: 7.2.3
LinkingTo: Rcpp
Imports: Rcpp, glue, mathjaxr
URL: https://const-ae.github.io/einsum/
BugReports: https://github.com/const-ae/einsum/issues
NeedsCompilation: yes
Packaged: 2026-07-08 21:55:52 UTC; ahlmanne
Author: Constantin Ahlmann-Eltze [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-3762-068X>),
  Koki Tsuyuzaki [aut] (ORCID: <https://orcid.org/0000-0003-3797-2148>)
Maintainer: Constantin Ahlmann-Eltze <artjom31415@googlemail.com>
Repository: CRAN
Date/Publication: 2026-07-09 08:10:08 UTC

<!-- README.md is generated from README.Rmd. Please edit that file -->

# einsum

<!-- badges: start -->

[![R build
status](https://github.com/const-ae/einsum/workflows/R-CMD-check/badge.svg)](https://github.com/const-ae/einsum/actions)
[![Codecov test
coverage](https://codecov.io/gh/const-ae/einsum/branch/master/graph/badge.svg)](https://app.codecov.io/gh/const-ae/einsum?branch=master)
<!-- badges: end -->

[Einstein summation](https://en.wikipedia.org/wiki/Einstein_notation) is
a concise mathematical notation that implicitly sums over repeated
indices of n-dimensional arrays. Many ordinary matrix operations (e.g.,
transpose, matrix multiplication, scalar product, ‘diag()’, trace, etc.)
can be written using Einstein notation. The notation is particularly
convenient for expressing operations on arrays with more than two
dimensions because the respective operators (‘tensor products’) might
not have a standardized name.

## Installation

You can install the package from
[CRAN](https://CRAN.R-project.org/package=einsum) with:

``` r
install.packages("einsum")
```

or if you want to use the development version from
[GitHub](https://github.com/einsum):

``` r
# install.packages("devtools")
devtools::install_github("const-ae/einsum")
```

## Example

Load the package:

``` r
library(einsum)
```

Let’s make two matrices:

``` r
mat1 <- matrix(rnorm(n = 8 * 4), nrow = 8, ncol = 4)
mat2 <- matrix(rnorm(n = 4 * 4), nrow = 4, ncol = 4)
```

We can use `einsum()` to calculate the matrix product

``` r
einsum("ij, jk -> ik", mat1, mat2)
#>            [,1]       [,2]       [,3]        [,4]
#> [1,] -0.5087677  0.6680792  0.2909357  0.49456493
#> [2,] -1.1888008  0.9411126  0.6737345  0.39054429
#> [3,] -1.4715071  1.0242759  0.2400887 -0.31436543
#> [4,]  0.3899863 -1.1212621 -0.7660189 -2.28836686
#> [5,] -0.9058902  0.5529122  0.4775118  0.18014286
#> [6,] -1.4494020  1.6341965  1.4738795  2.73834635
#> [7,] -0.5380896  0.8600228  0.4430880 -0.06022769
#> [8,]  3.0707573 -2.5552313 -1.5538108 -1.28101253
```

which produces the same as the standard matrix multiplication

``` r
mat1 %*% mat2
#>            [,1]       [,2]       [,3]        [,4]
#> [1,] -0.5087677  0.6680792  0.2909357  0.49456493
#> [2,] -1.1888008  0.9411126  0.6737345  0.39054429
#> [3,] -1.4715071  1.0242759  0.2400887 -0.31436543
#> [4,]  0.3899863 -1.1212621 -0.7660189 -2.28836686
#> [5,] -0.9058902  0.5529122  0.4775118  0.18014286
#> [6,] -1.4494020  1.6341965  1.4738795  2.73834635
#> [7,] -0.5380896  0.8600228  0.4430880 -0.06022769
#> [8,]  3.0707573 -2.5552313 -1.5538108 -1.28101253
```

The matrix multiplication example is straightforward, and there is
little benefit of using the Einstein notation over the more familiar
matrix product expression. Furthermore, ‘einsum’ is a lot slower.

However, ‘einsum’ truly shines when working with more than 2-dimensional
arrays, where it can be difficult to figure out the correct kind of
tensor product:

``` r
# Make three n-dimensional arrays
arr1 <- array(rnorm(3 * 9 * 2), dim = c(3, 9, 2))
arr2 <- array(rnorm(2 * 5), dim = c(2, 5))
arr3 <- array(rnorm(9 * 3), dim = c(9, 3))
# Sum across axes a, b, and c
einsum("abc, cd, ba -> d", arr1, arr2, arr3)
#> [1] -0.7015596 -4.0114655 -1.6420695 -3.4131292  0.7233701
```

The equivalent expression using tensor products (which are not
intuitive) would look like this:

``` r
tensor::tensor(tensor::tensor(arr1, arr2, alongA = 3, alongB = 1), arr3, alongA = c(2,1), alongB = c(1, 2))
#> [1] -0.7015596 -4.0114655 -1.6420695 -3.4131292  0.7233701
```

If you need to do the same computation repeatedly, you can use
`einsum_generator()`, which generates and compiles an efficient C++
function for that calculation (to see the function code, set
`compile_function=FALSE`). It can take a few seconds to compile the
function, but the returned function can be one or two orders of
magnitude faster than `einsum()`.

``` r
# einsum_generator returns a function
array_prod <- einsum_generator("abc, cd, ba -> d")
array_prod(arr1, arr2, arr3)
#> [1] -0.7015596 -4.0114655 -1.6420695 -3.4131292  0.7233701
```

``` r
bench::mark(
  tensor = tensor::tensor(tensor::tensor(arr1, arr2, alongA = 3, alongB = 1), 
                          arr3, alongA = c(2,1), alongB = c(1, 2)),
  einsum = einsum("abc, cd, ba -> d", arr1, arr2, arr3),
  einsum_generator = array_prod(arr1, arr2, arr3)
)
#> # A tibble: 3 × 6
#>   expression            min   median `itr/sec` mem_alloc `gc/sec`
#>   <bch:expr>       <bch:tm> <bch:tm>     <dbl> <bch:byt>    <dbl>
#> 1 tensor             48.6µs  52.02µs    18215.    2.93KB     25.4
#> 2 einsum           380.66µs 403.17µs     2373.    2.49KB     23.5
#> 3 einsum_generator   3.85µs   4.32µs   196916.    2.49KB     19.7
```

Lastly, you can also generate C++ code if you need an efficient
implementation of some function, which you could (with proper credit)
for example paste into your R package:

``` r
# The C++ code underlying the tensor product
cat(einsum_generator("abc, cd, ba -> d", compile_function = FALSE))
#> NumericVector einsum_impl_func(NumericVector array1, NumericVector array2, NumericVector array3){
#> NumericVector size(4);
#> IntegerVector array1_dim = array1.hasAttribute("dim") ? array1.attr("dim") : IntegerVector::create(array1.length());
#> IntegerVector array2_dim = array2.hasAttribute("dim") ? array2.attr("dim") : IntegerVector::create(array2.length());
#> IntegerVector array3_dim = array3.hasAttribute("dim") ? array3.attr("dim") : IntegerVector::create(array3.length());
#> size[0] = array1_dim[0];
#> if(size[0] != array3_dim[1]) stop("Dimension 2 of object array3 does not match!");
#> size[1] = array1_dim[1];
#> if(size[1] != array3_dim[0]) stop("Dimension 1 of object array3 does not match!");
#> size[2] = array1_dim[2];
#> if(size[2] != array2_dim[0]) stop("Dimension 1 of object array2 does not match!");
#> size[3] = array2_dim[1];
#> 
#> NumericVector result(size[3]);
#> for(int d = 0; d < size[3]; ++d){
#> double sum = 0.0;
#> for(int a = 0; a < size[0]; ++a){
#> for(int b = 0; b < size[1]; ++b){
#> for(int c = 0; c < size[2]; ++c){
#> sum += array1[1 * (a + size[0] * (b + size[1] * (c)))] * array2[1 * (c + size[2] * (d))] * array3[1 * (b + size[1] * (a))];
#> }
#> }
#> }
#> result[1 * (d)] = sum;
#> }
#> result.attr("dim") = IntegerVector::create(size[3]);
#> return result;
#> 
#> }
```

# Credit

This package is inspired by the
[einsum](https://numpy.org/doc/stable/reference/generated/numpy.einsum.html)
function in NumPy.

# einsum
> Experimental implementation of torch/onnx einsum

## Install

```bash
pip3 install -U einsum
```

Or develop locally:
```bash
git clone https://github.com/sorenlassen/einsum-experiment ~/einsum
cd ~/einsum
python3 setup.py develop
```

## Usage

```py
import einsum

print('TODO')
```

## Tests

Run `einsum`'s test suite:
```bash
pip3 install pytest
pytest
```

Type check with mypy:
```bash
pip3 install mypy
python3 -m mypy src/einsum/lib.py
```

## Release

To publish a new release to pypi:
```bash
pip3 install python-semantic-release

# verify tests pass.
pytest

# bump the version number, add a git tag.
semantic-release version --patch # or --minor, or --major

# push the new version number and tag to github.
git push && git push --tags

# publish to pypi.
poetry build
poetry publish
```

## About
`pyproject.toml` was generated with [mkpylib](https://github.com/shawwn/scrap/blob/master/mkpylib).
`setup.py` was generated with [poetry-gen-setup-py](https://github.com/shawwn/scrap/blob/master/poetry-gen-setup-py).

#' Einstein Summation
#'
#' Einstein summation is a concise mathematical notation that
#' implicitly sums over repeated indices of n-dimensional arrays. Many ordinary
#' matrix operations (e.g. transpose, matrix multiplication, scalar product, 'diag()', trace etc.)
#' can be written using Einstein notation. The notation is particularly convenient for
#' expressing operations on arrays with more than two dimensions because the
#' respective operators ('tensor products') might not have a standardized name.
#'
#' @docType package
#' @aliases einsum-package
#' @name einsum_package
NULL





## usethis namespace: start
#' @importFrom Rcpp sourceCpp
## usethis namespace: end
NULL


## usethis namespace: start
#' @useDynLib einsum, .registration = TRUE
## usethis namespace: end
NULL

#' @rdname einsum
#' @importFrom utils head
#' @export
einsum_generator <- function(equation_string, compile_function = TRUE){
  parsed <- parse_equation(equation_string)
  strings <- parsed$strings
  string_vec <- parsed$string_vec
  result_string_vec <- parsed$result_string_vec
  all_vars <- parsed$all_vars

  array_vars_list <- lapply(string_vec, function(st){
    vapply(st, function(s) which(all_vars == s) - 1L, FUN.VALUE = 0L)
  })
  result_vars_vec <-  vapply(result_string_vec, function(s) which(all_vars == s) - 1L, FUN.VALUE = 0L)
  not_result_vars_vec <- setdiff(seq_along(all_vars) - 1L, result_vars_vec)

  variable_names <- paste0("array", seq_along(array_vars_list))

  # --- Function declaration ---
  method_decl <- glue::glue('NumericVector einsum_impl_func(',
                            paste0("NumericVector ", variable_names, collapse = ", "),
                            "){{")

  # --- Size vector and dimension validation (shared by both paths) ---
  size_vec <- glue::glue('NumericVector size({length(all_vars)});\n')
  variable_dim_names <- paste0(variable_names, "_dim")
  for(idx in seq_along(variable_names)){
    size_vec <- paste0(size_vec, "\nIntegerVector ", variable_dim_names[idx], " = ", variable_names[idx], '.hasAttribute("dim") ? ',
                       variable_names[idx], '.attr("dim") : IntegerVector::create(', variable_names[idx], '.length());')
  }
  written <- rep(FALSE, length(all_vars))
  for(idx1 in seq_along(all_vars)){
    for(idx2 in seq_along(array_vars_list)){
      for(idx3 in which(all_vars[idx1] == names(array_vars_list[[idx2]]))){
        if(! written[idx1]){
          size_vec <- paste0(size_vec, "\n", paste0("size[",idx1-1, "] = ", variable_dim_names[idx2], '[', idx3 - 1, "];" ))
          written[idx1] <- TRUE
        }else{
          size_vec <- paste0(size_vec, "\nif(", paste0("size[",idx1-1, "] != ", variable_dim_names[idx2], '[', idx3 - 1, "])"),
                             ' stop("Dimension ',  idx3,' of object ', variable_names[idx2],' does not match!");')
        }
      }
    }
  }

  # --- Computation code ---
  # Try pairwise code generation for 3+ tensors without repeated indices.
  # For ≤2 tensors, repeated indices, or if pairwise path encounters
  # unsupported patterns (e.g. batch dimensions), fall back to the
  # original single-loop-nest code generation.
  use_pairwise <- can_use_pairwise(string_vec) && length(strings) >= 3
  computation_code <- NULL

  if(use_pairwise) {
    dummy_lengths <- rep(10, length(all_vars))
    names(dummy_lengths) <- all_vars
    path <- plan_contraction_path(string_vec, result_string_vec, dummy_lengths)
    computation_code <- generate_pairwise_cpp(
      path, string_vec, variable_names, result_string_vec, all_vars
    )
  }

  if(!is.null(computation_code)) {
    code <- paste0(method_decl, "\n", size_vec, "\n\n", computation_code, "\n}")
  } else {
    # --- Original single-loop-nest code generation ---
    if(length(result_vars_vec) == 0){
      for_loop_string <- glue::glue('NumericVector result(1);')
    }else{
      for_loop_string <- glue::glue('NumericVector result({paste0("size[", result_vars_vec, "]", collapse = " * ")});')
    }
    for(res_var in result_vars_vec){
      for_loop_string <- glue::glue('|{for_loop_string}
                                     |for(int {all_vars[res_var +1]} = 0; {all_vars[res_var+1]} < size[{res_var}]; ++{all_vars[res_var+1]}){{')

    }
    for_loop_string <- glue::glue('|{for_loop_string}
                                   |double sum = 0.0;')
    for(sum_var in not_result_vars_vec){
      for_loop_string <- glue::glue('|{for_loop_string}
                                     |for(int {all_vars[sum_var +1]} = 0; {all_vars[sum_var+1]} < size[{sum_var}]; ++{all_vars[sum_var+1]}){{')
    }
    prod_string <- paste(sapply(seq_along(variable_names), function(idx){
      summands <-  paste0(c("1", glue::glue('size[{head(array_vars_list[[idx]],n=length(array_vars_list[[idx]])-1)}]')),
                            " * (", all_vars[array_vars_list[[idx]] + 1])
      glue::glue('{variable_names[idx]}[', paste0(paste0(summands, collapse = " + "), paste0(rep(")", times = length(array_vars_list[[idx]])), collapse = "")), "]")
    }), collapse = " * ")
    for_loop_string <- glue::glue('|{for_loop_string}
                                   |sum += {prod_string};')

    for_loop_string <- glue::glue('|{for_loop_string}
                                   |{paste0(rep("}", times = length(not_result_vars_vec)), collapse = "\n")}')
    if(length(result_vars_vec) == 0){
      assignment_lhs <- 'result[0]'
    }else{
      summands <-  paste0(c("1", glue::glue('size[{head(result_vars_vec,n=length(result_vars_vec)-1)}]')),
                          " * (", all_vars[result_vars_vec + 1])
      assignment_lhs <- glue::glue('result[', paste0(paste0(summands, collapse = " + "), paste0(rep(")", times = length(result_vars_vec)), collapse = "")), "]")
    }
    for_loop_string <- glue::glue('|{for_loop_string}
                                   |{assignment_lhs} = sum;')
    for_loop_string <- glue::glue('|{for_loop_string}
                                   |{paste0(rep("}", times = length(result_vars_vec)), collapse = "\n")}
                                   |result.attr("dim") = IntegerVector::create({ if(length(result_vars_vec) == 0) 1 else paste0("size[", result_vars_vec ,"]", collapse = ",")});
                                   |return result;')
    code <- paste0(method_decl, "\n", size_vec, "\n", gsub(pattern = "\\s*\\|+", "\n",  for_loop_string), "\n\n}")
  }

  if(! compile_function){
    code
  }else{
    Rcpp::cppFunction(code)
  }
}


# Generate C++ code for a sequence of pairwise contraction steps.
generate_pairwise_cpp <- function(path, string_vec, variable_names,
                                  result_string_vec, all_vars) {
  current_names <- variable_names
  current_string_vec <- string_vec
  temp_count <- 0L
  code <- ""

  for(step_idx in seq_along(path)) {
    step <- path[[step_idx]]
    i <- step$i
    j <- step$j

    name1 <- current_names[i]
    name2 <- current_names[j]
    chars1 <- current_string_vec[[i]]
    chars2 <- current_string_vec[[j]]

    is_last <- (step_idx == length(path))
    if(is_last) {
      out_name <- "result"
      out_chars <- result_string_vec
    } else {
      temp_count <- temp_count + 1L
      out_name <- paste0("temp", temp_count)
      out_chars <- step$result_chars
    }

    code <- paste0(code, generate_single_contraction_cpp(
      name1, chars1, name2, chars2, out_name, out_chars, all_vars
    ))

    current_names <- c(current_names[-c(i, j)], out_name)
    current_string_vec <- c(current_string_vec[-c(i, j)], list(out_chars))
  }

  # dim attribute and return
  if(length(result_string_vec) == 0) {
    dim_expr <- "1"
  } else {
    var_indices <- vapply(result_string_vec, function(ch) which(all_vars == ch) - 1L, 0L)
    dim_expr <- paste0("size[", var_indices, "]", collapse = ", ")
  }
  code <- paste0(code, 'result.attr("dim") = IntegerVector::create(', dim_expr, ');\n')
  code <- paste0(code, "return result;\n")
  code
}


# Generate C++ code for a single two-tensor contraction step.
generate_single_contraction_cpp <- function(name1, chars1, name2, chars2,
                                            result_name, result_chars, all_vars) {
  all_local <- unique(c(chars1, chars2))
  contracted <- setdiff(all_local, result_chars)

  # Column-major flat index expression: 1 * (c1 + size[s1] * (c2 + size[s2] * (c3)))
  make_index_expr <- function(chars) {
    if(length(chars) == 0) return("0")
    if(length(chars) == 1) return(chars)
    var_indices <- vapply(chars, function(ch) which(all_vars == ch) - 1L, 0L)
    summands <- paste0(
      c("1", paste0("size[", head(var_indices, -1), "]")),
      " * (", chars
    )
    paste0(paste0(summands, collapse = " + "),
           paste0(rep(")", length(chars)), collapse = ""))
  }

  # Result array declaration
  if(length(result_chars) == 0) {
    code <- paste0("NumericVector ", result_name, "(1);\n")
  } else {
    var_indices <- vapply(result_chars, function(ch) which(all_vars == ch) - 1L, 0L)
    size_expr <- paste0("size[", var_indices, "]", collapse = " * ")
    code <- paste0("NumericVector ", result_name, "(", size_expr, ");\n")
  }

  # Outer loops (result indices)
  for(rc in result_chars) {
    vi <- which(all_vars == rc) - 1L
    code <- paste0(code, "for(int ", rc, " = 0; ", rc, " < size[", vi, "]; ++", rc, "){\n")
  }

  code <- paste0(code, "double sum = 0.0;\n")

  # Inner loops (contracted indices)
  for(cc in contracted) {
    vi <- which(all_vars == cc) - 1L
    code <- paste0(code, "for(int ", cc, " = 0; ", cc, " < size[", vi, "]; ++", cc, "){\n")
  }

  # Product
  idx1 <- make_index_expr(chars1)
  idx2 <- make_index_expr(chars2)
  code <- paste0(code, "sum += ", name1, "[", idx1, "] * ", name2, "[", idx2, "];\n")

  # Close inner loops
  code <- paste0(code, paste0(rep("}\n", length(contracted)), collapse = ""))

  # Assignment
  if(length(result_chars) == 0) {
    code <- paste0(code, result_name, "[0] = sum;\n")
  } else {
    code <- paste0(code, result_name, "[", make_index_expr(result_chars), "] = sum;\n")
  }

  # Close outer loops
  code <- paste0(code, paste0(rep("}\n", length(result_chars)), collapse = ""))

  code
}

test_that("basic matrix operations work", {

  mat1 <- matrix(rnorm(n = 4 * 8), nrow = 4, ncol = 8)
  mat2 <- matrix(rnorm(n = 8 * 3), nrow = 8, ncol = 3)

  # Matrix Multiply
  expect_equal(einsum("ij,jk->ik", mat1, mat2), mat1 %*% mat2)
  expect_equal(einsum("ij,jk->ik", mat1, mat2), tcrossprod(mat1, t(mat2)))
  expect_equal(einsum("ij,jk->ik", mat1, mat2), einsum_generator("ij,jk->ik")(mat1, mat2))

  # Diag
  mat_sq <- matrix(rnorm(n = 4 * 4), nrow = 4, ncol = 4)
  expect_equal(c(einsum("ii->i", mat_sq)), diag(mat_sq))
  expect_equal(einsum("ii->i", mat_sq), einsum_generator("ii->i")(mat_sq))

  expect_equal(einsum("ii->ii", mat_sq), diag(diag(mat_sq)))
  expect_equal(einsum("ii->ii", mat_sq), einsum_generator("ii->ii")(mat_sq))

  expect_equal(einsum("ii->iii", mat_sq), einsum_generator("ii->iii")(mat_sq))

  # Trace
  expect_equal(c(einsum("ii->", mat_sq)), sum(diag(mat_sq)))
  expect_equal(einsum("ii->", mat_sq), einsum_generator("ii->")(mat_sq))

  # Row sum
  expect_equal(c(einsum("ij->i", mat1)), rowSums(mat1))
  expect_equal(einsum("ij->i", mat1), einsum_generator("ij->i")(mat1))

  # Col sum
  expect_equal(c(einsum("ij->j", mat1)), colSums(mat1))
  expect_equal(einsum("ij->j", mat1), einsum_generator("ij->j")(mat1))

  # Scalar product
  mat3 <- matrix(rnorm(n = 4 * 8), nrow = 4, ncol = 8)
  expect_equal(einsum("ij,ij->ij", mat3, mat1), mat3 * mat1)
  expect_equal(einsum("ij,ij->ij", mat3, mat1), einsum_generator("ij,ij->ij")(mat3, mat1))

  # Transpose
  expect_equal(einsum("ij->ji", mat1), t(mat1))
  expect_equal(einsum("ij->ji", mat1), einsum_generator("ij->ji")(mat1))

  # Matrix times vector
  vec <- rnorm(8)
  expect_equal(c(einsum("ij,j->i", mat3, vec)), c(mat3 %*% vec))
  expect_equal(einsum("ij,j->i", mat3, vec), einsum_generator("ij,j->i")(mat3, vec))

  # Batched L2 norm
  arr1 <- array(c(mat1, mat3), dim = c(dim(mat1), 2))  # eq. to abind()
  expect_equal(c(einsum("ijb,ijb->b", arr1, arr1)), c(sum(mat1^2), sum(mat3^2)))
  expect_equal(einsum("ijb,ijb->b", arr1, arr1), einsum_generator("ijb,ijb->b")(arr1, arr1))

  # More complex example
  expect_equal(c(einsum("ij,kj,kl,l->i", mat1, mat3, mat_sq, c(1:4))), c((mat1 %*% t(mat3)) %*% mat_sq %*% c(1:4)))
  expect_equal(einsum("ij,kj,kl,l->i", mat1, mat3, mat_sq, c(1:4)), einsum_generator("ij,kj,kl,l->i")(mat1, mat3, mat_sq, c(1:4)))

})


test_that("einsum can handle whitespace in equation_string", {
  mat1 <- matrix(rnorm(n = 4 * 8), nrow = 4, ncol = 8)
  mat2 <- matrix(rnorm(n = 8 * 3), nrow = 8, ncol = 3)

  expect_equal(einsum("ij,j k -> ik", mat1, mat2), mat1 %*% mat2)
})



test_that("einsum gives appropriate error messages", {
  mat1 <- matrix(rnorm(n = 4 * 8), nrow = 4, ncol = 8)
  mat2 <- matrix(rnorm(n = 8 * 3), nrow = 8, ncol = 3)

  # j is 8 and 3
  expect_error(einsum("ij,jj -> ik", mat1, mat2))

  # more arrays than elements in the lhs
  expect_error(einsum("ij,jj -> ik", mat1, mat2, mat1))

  # length(dim(array)) does not match number of indices
  expect_error(einsum("ij,jk -> ik", mat1, 1:5))

  # Invalid character in equation_string
  expect_error(einsum("ij,jk -> i3k", mat1, mat2))
  expect_error(einsum("ij,j$k -> ik", mat1, mat2))

  # Missing ->
  expect_error(einsum("ij,jk", mat1, mat2))

  # Multiple ->
  expect_error(einsum("ij,jk->k->a", mat1, mat2))

  # Wrong index in result
  expect_error(einsum("ij,jk -> a", mat1, mat2))

})

test_that("einsum_generator gives appropriate error messages", {

  # Missing ->
  expect_error(einsum_generator("ij,jk"))

  # Multiple ->
  expect_error(einsum_generator("ij,jk->k->a"))

  # Wrong index in result
  expect_error(einsum_generator("ij,jk -> a"))

})



# quad_mm <- einsum_generator("ij,kj,kl,l->i")
#
# i <- 3
# j <- 500
# k <- 70
# l <- 200
#
# mat1 <- array(rnorm(n = i * j), dim = c(i,j))
# mat2 <- array(rnorm(n = k * j), dim = c(k,j))
# mat3 <- array(rnorm(n = k * l), dim = c(k,l))
# mat4 <- array(rnorm(n = l), dim = c(l))
#
# bench::mark(base_r = c((mat1 %*% t(mat2)) %*% mat3 %*% mat4),
#             einsum = c(einsum("ij,kj,kl,l->i", mat1, mat2, mat3, mat4)),
#             einsum_compiled = c(quad_mm(mat1, mat2, mat3, mat4)))

test_that("einsum handles many indices via optimized pairwise contraction", {
  n <- 4

  # Non-alphabetical index names: xp,pq->xq
  a1 <- array(rnorm(n^2), dim = c(n, n))
  a2 <- array(rnorm(n^2), dim = c(n, n))
  expect_equal(einsum("xp,pq->xq", a1, a2), a1 %*% a2)

  # 5 unique indices with gaps: mwkr,wkrn->mn
  a3 <- array(rnorm(n^4), dim = rep(n, 4))
  a4 <- array(rnorm(n^4), dim = rep(n, 4))
  res <- einsum("mwkr,wkrn->mn", a3, a4)
  ref <- einsum_generator("mwkr,wkrn->mn")(a3, a4)
  expect_equal(res, ref)

  # 7 unique indices with mixed case: pAqBrC,AqBrCz->pz
  a5 <- array(rnorm(n^6), dim = rep(n, 6))
  a6 <- array(rnorm(n^6), dim = rep(n, 6))
  res <- einsum("pAqBrC,AqBrCz->pz", a5, a6)
  ref <- einsum_generator("pAqBrC,AqBrCz->pz")(a5, a6)
  expect_equal(res, ref)

  # result in reversed order: mwkr,wkrn->nm
  res <- einsum("mwkr,wkrn->nm", a3, a4)
  ref <- einsum_generator("mwkr,wkrn->nm")(a3, a4)
  expect_equal(res, ref)

  # scalar result (all indices contracted): xp,xp->
  res <- einsum("xp,xp->", a1, a2)
  expect_equal(c(res), sum(a1 * a2))

  # three tensors: gx,xr,rw->gw
  a7 <- array(rnorm(n^2), dim = c(n, n))
  res <- einsum("gx,xr,rw->gw", a1, a2, a7)
  ref <- einsum_generator("gx,xr,rw->gw")(a1, a2, a7)
  expect_equal(res, ref)

  # four tensors: nk,kq,qh,hZ->nZ
  a8 <- array(rnorm(n^2), dim = c(n, n))
  res <- einsum("nk,kq,qh,hZ->nZ", a1, a2, a7, a8)
  ref <- einsum_generator("nk,kq,qh,hZ->nZ")(a1, a2, a7, a8)
  expect_equal(res, ref)
})


test_that("einsum_generator uses pairwise contraction for 3+ tensors", {
  n <- 4
  a1 <- array(rnorm(n^2), dim = c(n, n))
  a2 <- array(rnorm(n^2), dim = c(n, n))
  a3 <- array(rnorm(n^2), dim = c(n, n))
  a4 <- array(rnorm(n^2), dim = c(n, n))

  # Three tensors: generated code should use intermediate temps
  gen3 <- einsum_generator("gx,xr,rw->gw")
  expect_equal(gen3(a1, a2, a3), einsum("gx,xr,rw->gw", a1, a2, a3))

  code3 <- einsum_generator("gx,xr,rw->gw", compile_function = FALSE)
  expect_true(grepl("temp1", code3))

  # Four tensors
  gen4 <- einsum_generator("nk,kq,qh,hZ->nZ")
  expect_equal(gen4(a1, a2, a3, a4), einsum("nk,kq,qh,hZ->nZ", a1, a2, a3, a4))

  # Scalar result from three tensors
  gen_scalar <- einsum_generator("pq,qr,rp->")
  expect_equal(gen_scalar(a1, a2, a3), einsum("pq,qr,rp->", a1, a2, a3))

  # Non-trivial index order in result
  gen_rev <- einsum_generator("xr,rw,wm->mx")
  expect_equal(gen_rev(a1, a2, a3), einsum("xr,rw,wm->mx", a1, a2, a3))

  # Mixed-case indices
  gen_mixed <- einsum_generator("aB,Bc,cD->aD")
  expect_equal(gen_mixed(a1, a2, a3), einsum("aB,Bc,cD->aD", a1, a2, a3))

  # Repeated indices within a tensor still works (falls back to single loop)
  gen_diag <- einsum_generator("ii,ij->j")
  mat_sq <- array(rnorm(n^2), dim = c(n, n))
  expect_equal(c(gen_diag(mat_sq, a1)), c(diag(mat_sq) %*% a1))
})

#' Einstein Summation
#'

#'
#' @param equation_string a string in Einstein notation where arrays
#'   are separated by ',' and the result is separated by '->'. For
#'   example \code{"ij,jk->ik"} corresponds to a standard matrix multiplication.
#'   Whitespace inside the \code{equation_string} is ignored. Unlike the
#'   equivalent functions in Python, \code{einsum()} only supports the explicit
#'   mode. This means that the \code{equation_string} must contain '->'.
#' @param compile_function boolean that decides if \code{einsum_generator()}
#'   returns the result of \code{Rcpp::cppFunction()} or the program as a
#'   string. Default: \code{TRUE}.
#' @param ... the arrays that are combined. All arguments are converted
#'   to arrays with \code{as.array}.
#'
#' @description
#' \loadmathjax
#' Einstein summation is a convenient and concise notation for operations
#' on n-dimensional arrays.
#'
#'
#' @details
#' The following table show, how the Einstein notation abbreviates complex
#' summation for arrays/matrices:
#'
#' \tabular{lrr}{
#'   \code{equation_string} \tab Formula \tab \cr
#'   ------------------------\tab--------------------------------------\tab----------------------------------\cr
#'   \code{"ij,jk->ik"} \tab \mjseqn{ Y_{ik} = \sum_{j}{A_{ij} B_{jk}}  } \tab Matrix multiplication \cr
#'   \code{"ij->ji"}` \tab \mjseqn{ Y = A^{T}  } \tab Transpose \cr
#'   \code{"ii->i"} \tab \mjeqn{y = \textrm{diag}(A)}{y = diag(A)} \tab Diagonal \cr
#'   \code{"ii->ii"} \tab \mjeqn{Y = \textrm{diag}(A) I}{Y = diag(A) I} \tab Diagonal times Identity  \cr
#'   \code{"ii->"} \tab \mjeqn{y = \textrm{trace}(A) = \sum_i{A_{ii}} }{y = trace(A) = Sum_i(A_{ii})} \tab Trace \cr
#'   \code{"ijk,mjj->i"} \tab \mjeqn{ y_i = \sum_{j}\sum_{k}\sum_{m}A_{ijk}B_{mjj}  }{y_i = Sum_j Sum_k Sum_m A_{ijk} B_{mjj}} \tab Complex 3D operation  \cr
#' }
#'
#'
#' The function and the conventions are inspired by the \code{einsum()} function
#' in NumPy (\href{https://numpy.org/doc/stable/reference/generated/numpy.einsum.html}{documentation}).
#' Unlike NumPy, 'einsum' only supports the explicit mode. The explicit mode is more flexible and
#' can avoid confusion. The common summary of the Einstein  summation to
#' "sum over duplicated indices" however is not a good mental model. A better rule of thumb is
#' "sum over all indices not in the result".
#'
#' \emph{Note:} \code{einsum()} internally uses C++ code to provide results quickly, the repeated
#' parsing of the \code{equation_string} comes with some overhead. Thus,
#' if you need to do the same calculation over and over again it can be worth to use
#' \code{einsum_generator()} and call the returned the function. \code{einsum_generator()}
#' generates efficient C++ code that can be one or two orders of magnitude faster than
#' \code{einsum()}.
#'
#' @return
#'  The \code{einsum()} function returns an array with one dimension for each index in the result
#'  of the \code{equation_string}. For example \code{"ij,jk->ik"} produces a 2-dimensional array,
#'  \code{"abc,cd,de->abe"} produces a 3-dimensional array.
#'
#'  The \code{einsum_generator()} function returns a function that takes one array for each
#'  comma-separated input in the \code{equation_string} and returns the same result as \code{einsum()}.
#'  Or if \code{compile_function = FALSE}, \code{einsum_generator()} function returns a string with the
#'  C++ code for such a function.
#'
#' @examples
#' mat1 <- matrix(rnorm(n = 4 * 8), nrow = 4, ncol = 8)
#' mat2 <- matrix(rnorm(n = 8 * 3), nrow = 8, ncol = 3)
#'
#' # Matrix Multiply
#' mat1 %*% mat2
#' einsum("ij,jk -> ik", mat1, mat2)
#'
#' # einsum_generator() works just like einsum() but returns a performant function
#' mat_mult <- einsum_generator("ij,jk -> ik")
#' mat_mult(mat1, mat2)
#'
#' # Diag
#' mat_sq <- matrix(rnorm(n = 4 * 4), nrow = 4, ncol = 4)
#' diag(mat_sq)
#' einsum("ii->i", mat_sq)
#' einsum("ii->ii", mat_sq)
#'
#' # Trace
#' sum(diag(mat_sq))
#' einsum("ii->", mat_sq)
#'
#'
#' # Scalar product
#' mat3 <- matrix(rnorm(n = 4 * 8), nrow = 4, ncol = 8)
#' mat3 * mat1
#' einsum("ij,ij->ij", mat3, mat1)
#'
#' # Transpose
#' t(mat1)
#' einsum("ij->ji", mat1)
#'
#'
#' # Batched L2 norm
#' arr1 <- array(c(mat1, mat3), dim = c(dim(mat1), 2))
#' c(sum(mat1^2), sum(mat3^2))
#' einsum("ijb,ijb->b", arr1, arr1)
#'
#' @export
einsum <- function(equation_string, ...){
  arrays <- list(...)
  arrays <- lapply(arrays, as.array)

  parsed <- parse_equation(equation_string)
  strings <- parsed$strings
  string_vec <- parsed$string_vec
  result_string_vec <- parsed$result_string_vec
  all_vars <- parsed$all_vars

  stopifnot("The number of strings on the left-hand side does not match the number of arrays" =
              length(strings) == length(arrays))
  stopifnot("Number of dimensions of array does not match the number of indices" =
              all(nchar(strings) == vapply(arrays, function(a)length(dim(a)), 0.0)))

  # Get the lengths of the indices as a named vector
  lengths_vec <- get_lengths_vec(strings, arrays)

  # Try optimized pairwise contraction with BLAS matrix multiply
  if(can_use_pairwise(string_vec)) {
    path <- plan_contraction_path(string_vec, result_string_vec, lengths_vec)
    result <- einsum_execute_path(path, string_vec, result_string_vec, arrays)
    if(!is.null(result)) return(result)
  }

  # Fall back to generic C++ implementation
  lengths_vec <- lengths_vec[order(names(lengths_vec))]
  array_vars_list <- lapply(string_vec, function(st){
    vapply(st, function(s) which(all_vars == s) - 1L, FUN.VALUE = 0L)
  })
  result_vars_vec <-  vapply(result_string_vec, function(s) which(all_vars == s) - 1L, FUN.VALUE = 0L)
  not_result_vars_vec <- setdiff(seq_along(all_vars) - 1L, result_vars_vec)

  einsum_impl_fast(lengths_vec, array_vars_list, not_result_vars_vec, result_vars_vec, arrays)

}


# Execute a pre-planned contraction path using BLAS matrix multiply.
# Returns NULL if any step is unsupported, so the caller can fall back
# to the generic C++ engine.
einsum_execute_path <- function(path, string_vec, result_string_vec, arrays) {
  current_string_vec <- string_vec
  current_arrays <- arrays

  for(step in path) {
    i <- step$i
    j <- step$j

    pair_result <- einsum_contract_pair(
      current_string_vec[[i]], current_string_vec[[j]],
      step$result_chars,
      current_arrays[[i]], current_arrays[[j]]
    )
    if(is.null(pair_result)) return(NULL)

    current_string_vec <- c(current_string_vec[-c(i, j)], list(step$result_chars))
    current_arrays <- c(current_arrays[-c(i, j)], list(pair_result))
  }

  # Single tensor remains — permute to final result order if needed
  res <- current_arrays[[1]]
  final_chars <- current_string_vec[[1]]
  if(length(result_string_vec) > 0 && length(final_chars) > 0 &&
     !identical(final_chars, result_string_vec)) {
    res <- aperm(res, match(result_string_vec, final_chars))
  }
  res
}


# Contract two tensors via BLAS matrix multiply.
# Returns NULL if the contraction pattern is not supported (e.g. repeated
# indices within a single tensor, or batch dimensions).
einsum_contract_pair <- function(chars1, chars2, result_chars, arr1, arr2) {

  # Repeated indices within a tensor (e.g. "ii") need the C++ path
  if(length(chars1) != length(unique(chars1)) || length(chars2) != length(unique(chars2)))
    return(NULL)

  shared <- intersect(chars1, chars2)
  contracted <- setdiff(shared, result_chars)
  batch <- intersect(shared, result_chars)
  free1 <- setdiff(chars1, chars2)
  free2 <- setdiff(chars2, chars1)

  # Batch dimensions (index in both tensors AND result) not yet supported
  if(length(batch) > 0) return(NULL)

  # Permute arr1 to (free1..., contracted...) and arr2 to (contracted..., free2...)
  perm1 <- match(c(free1, contracted), chars1)
  perm2 <- match(c(contracted, free2), chars2)

  a1 <- if(identical(perm1, seq_along(chars1))) arr1 else aperm(arr1, perm1)
  a2 <- if(identical(perm2, seq_along(chars2))) arr2 else aperm(arr2, perm2)

  d1 <- dim(a1)
  d2 <- dim(a2)

  nf1 <- if(length(free1) > 0) prod(d1[seq_along(free1)]) else 1L
  nc  <- if(length(contracted) > 0) prod(d1[length(free1) + seq_along(contracted)]) else 1L
  nf2 <- if(length(free2) > 0) prod(d2[length(contracted) + seq_along(free2)]) else 1L

  # Reshape to 2D matrices and use BLAS
  dim(a1) <- c(nf1, nc)
  dim(a2) <- c(nc, nf2)
  res <- a1 %*% a2

  # Restore output dimensions
  out_chars <- c(free1, free2)
  out_dims <- c(
    if(length(free1) > 0) d1[seq_along(free1)] else integer(0),
    if(length(free2) > 0) d2[length(contracted) + seq_along(free2)] else integer(0)
  )

  if(length(out_dims) == 0) {
    res <- array(as.numeric(res), dim = 1L)
  } else {
    dim(res) <- out_dims
  }

  # Permute to match desired result index order
  if(length(result_chars) > 0 && length(out_chars) > 0 && !identical(out_chars, result_chars)) {
    res <- aperm(res, match(result_chars, out_chars))
  }

  res
}



get_lengths_vec <- function(strings, objects){
  keys <- unlist(strsplit(strings, ""))
  values <- unlist(lapply(objects, dim))
  lengths <- numeric(length(unique(keys)))
  names(lengths) <- unique(keys)
  for(key in unique(keys)){
    pos_values <- values[which(keys == key)]
    if(any(pos_values != pos_values[1])){
      stop("The length for index '", key, "' differ: ", paste0(unique(pos_values), collapse = ", "), "\n",
           "Dimensions with the same index must have the same length.")
    }
    lengths[key] <- pos_values[1]
  }
  lengths
}

# This is useful locally, but I comment out this code because I don't want to depend on reticulate


# np <- reticulate::import("numpy")
#
# test_that("einsum and numpy$einsum agree", {
#
#   mat1 <- matrix(rnorm(n = 4 * 8), nrow = 4, ncol = 8)
#   mat2 <- matrix(rnorm(n = 8 * 3), nrow = 8, ncol = 3)
#
#   # Matrix Multiply
#   expect_equal(einsum("ij,jk->ik", mat1, mat2), np$einsum("ij,jk->ik", mat1, mat2))
#
#   # Diag
#   mat_sq <- matrix(rnorm(n = 4 * 4), nrow = 4, ncol = 4)
#   expect_equal(einsum("ii->i", mat_sq), np$einsum("ii->i", mat_sq))
#
#   # Trace
#   expect_equal(c(einsum("ii->", mat_sq)), np$einsum("ii->", mat_sq))
#
#   # Row sum
#   expect_equal(einsum("ij->i", mat1), np$einsum("ij->i", mat1))
#
#   # Col sum
#   expect_equal(einsum("ij->j", mat1), np$einsum("ij->j", mat1))
#
#   # Scalar product
#   mat3 <- matrix(rnorm(n = 4 * 8), nrow = 4, ncol = 8)
#   expect_equal(einsum("ij,ij->ij", mat3, mat1), np$einsum("ij,ij->ij", mat3, mat1))
#
#   # Transpose
#   expect_equal(einsum("ij->ji", mat1), np$einsum("ij->ji", mat1))
#
#   # Matrix times vector
#   vec <- rnorm(8)
#   expect_equal(einsum("ij,j->i", mat3, vec), np$einsum("ij,j->i", mat3, vec))
#
#   # Batched L2 norm
#   arr1 <- array(c(mat1, mat3), dim = c(dim(mat1), 2))  # eq. to abind()
#   expect_equal(einsum("ijb,ijb->b", arr1, arr1), np$einsum("ijb,ijb->b", arr1, arr1))
#
# })

# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

einsum_impl_fast <- function(lengths_vec, array_vars_list, not_result_vars_vec, result_vars_vec, arrays) {
    .Call(`_einsum_einsum_impl_fast`, lengths_vec, array_vars_list, not_result_vars_vec, result_vars_vec, arrays)
}

# Shared equation parsing and contraction path planning for einsum() and
# einsum_generator().

parse_equation <- function(equation_string) {
  equation_string <- gsub("\\s", "", equation_string)
  if(length(grep("->", equation_string)) == 0){
    stop("The 'equation_string' must contain `->`: ", equation_string)
  }
  tmp <- strsplit(equation_string, "->")[[1]]
  result_string <- if(length(tmp) == 1) ""
  else if(length(tmp) == 2) tmp[2]
  else stop("the equation string contains more than one '->': ", equation_string)
  lhs_strings <- tmp[1]
  strings <- unlist(strsplit(lhs_strings, ","))
  if(any(grepl("[^a-zA-Z]", strings)) || grepl("[^a-zA-Z]", result_string))
    stop("'equation_string' contains a non alphabetical (a-z and A-Z) character.")
  result_string_vec <- strsplit(result_string, "")[[1]]
  string_vec <- strsplit(strings, "")
  all_vars <- sort(unique(unlist(string_vec)))
  if(! all(result_string_vec %in% all_vars)){
    missing_result_indices <- setdiff(result_string_vec, all_vars)
    stop("The result contains indices (", paste0(missing_result_indices, collapse = ", "),
         ") which are not on the left-hand side: ", equation_string)
  }
  list(
    strings = strings,
    string_vec = string_vec,
    result_string = result_string,
    result_string_vec = result_string_vec,
    all_vars = all_vars
  )
}


# Check whether pairwise contraction can be applied: requires 2+ tensors
# and no repeated indices within any single tensor (e.g. "ii").
can_use_pairwise <- function(string_vec) {
  length(string_vec) >= 2 &&
    !any(vapply(string_vec, function(sv) length(sv) != length(unique(sv)), FALSE))
}


# Greedy contraction path: at each step, pick the tensor pair whose
# contraction involves the fewest total elements.
# Returns a list of steps, each containing: i, j (positions in the current
# tensor list), chars_i, chars_j, and result_chars.
plan_contraction_path <- function(string_vec, result_string_vec, lengths_vec) {
  current_string_vec <- string_vec
  steps <- list()

  while(length(current_string_vec) > 1) {
    n <- length(current_string_vec)
    best_cost <- Inf
    best_i <- 1L
    best_j <- 2L
    for(i in 1:(n - 1)) {
      for(j in (i + 1):n) {
        ij_chars <- unique(c(current_string_vec[[i]], current_string_vec[[j]]))
        cost <- prod(lengths_vec[ij_chars])
        if(cost < best_cost) {
          best_cost <- cost
          best_i <- i
          best_j <- j
        }
      }
    }

    i <- best_i
    j <- best_j

    other_chars <- unique(unlist(current_string_vec[-c(i, j)]))
    needed <- union(result_string_vec, other_chars)
    ij_chars <- unique(c(current_string_vec[[i]], current_string_vec[[j]]))
    intermediate_chars <- intersect(ij_chars, needed)

    steps <- c(steps, list(list(
      i = i, j = j,
      chars_i = current_string_vec[[i]],
      chars_j = current_string_vec[[j]],
      result_chars = intermediate_chars
    )))

    current_string_vec <- c(current_string_vec[-c(i, j)], list(intermediate_chars))
  }
  steps
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/einsum.R, R/einsum_generator.R
\name{einsum}
\alias{einsum}
\alias{einsum_generator}
\title{Einstein Summation}
\usage{
einsum(equation_string, ...)

einsum_generator(equation_string, compile_function = TRUE)
}
\arguments{
\item{equation_string}{a string in Einstein notation where arrays
are separated by ',' and the result is separated by '->'. For
example \code{"ij,jk->ik"} corresponds to a standard matrix multiplication.
Whitespace inside the \code{equation_string} is ignored. Unlike the
equivalent functions in Python, \code{einsum()} only supports the explicit
mode. This means that the \code{equation_string} must contain '->'.}

\item{...}{the arrays that are combined. All arguments are converted
to arrays with \code{as.array}.}

\item{compile_function}{boolean that decides if \code{einsum_generator()}
returns the result of \code{Rcpp::cppFunction()} or the program as a
string. Default: \code{TRUE}.}
}
\value{
The \code{einsum()} function returns an array with one dimension for each index in the result
 of the \code{equation_string}. For example \code{"ij,jk->ik"} produces a 2-dimensional array,
 \code{"abc,cd,de->abe"} produces a 3-dimensional array.

 The \code{einsum_generator()} function returns a function that takes one array for each
 comma-separated input in the \code{equation_string} and returns the same result as \code{einsum()}.
 Or if \code{compile_function = FALSE}, \code{einsum_generator()} function returns a string with the
 C++ code for such a function.
}
\description{
\loadmathjax
Einstein summation is a convenient and concise notation for operations
on n-dimensional arrays.
}
\details{
The following table show, how the Einstein notation abbreviates complex
summation for arrays/matrices:

\tabular{lrr}{
  \code{equation_string} \tab Formula \tab \cr
  ------------------------\tab--------------------------------------\tab----------------------------------\cr
  \code{"ij,jk->ik"} \tab \mjseqn{ Y_{ik} = \sum_{j}{A_{ij} B_{jk}}  } \tab Matrix multiplication \cr
  \code{"ij->ji"}` \tab \mjseqn{ Y = A^{T}  } \tab Transpose \cr
  \code{"ii->i"} \tab \mjeqn{y = \textrm{diag}(A)}{y = diag(A)} \tab Diagonal \cr
  \code{"ii->ii"} \tab \mjeqn{Y = \textrm{diag}(A) I}{Y = diag(A) I} \tab Diagonal times Identity  \cr
  \code{"ii->"} \tab \mjeqn{y = \textrm{trace}(A) = \sum_i{A_{ii}} }{y = trace(A) = Sum_i(A_{ii})} \tab Trace \cr
  \code{"ijk,mjj->i"} \tab \mjeqn{ y_i = \sum_{j}\sum_{k}\sum_{m}A_{ijk}B_{mjj}  }{y_i = Sum_j Sum_k Sum_m A_{ijk} B_{mjj}} \tab Complex 3D operation  \cr
}


The function and the conventions are inspired by the \code{einsum()} function
in NumPy (\href{https://numpy.org/doc/stable/reference/generated/numpy.einsum.html}{documentation}).
Unlike NumPy, 'einsum' only supports the explicit mode. The explicit mode is more flexible and
can avoid confusion. The common summary of the Einstein  summation to
"sum over duplicated indices" however is not a good mental model. A better rule of thumb is
"sum over all indices not in the result".

\emph{Note:} \code{einsum()} internally uses C++ code to provide results quickly, the repeated
parsing of the \code{equation_string} comes with some overhead. Thus,
if you need to do the same calculation over and over again it can be worth to use
\code{einsum_generator()} and call the returned the function. \code{einsum_generator()}
generates efficient C++ code that can be one or two orders of magnitude faster than
\code{einsum()}.
}
\examples{
mat1 <- matrix(rnorm(n = 4 * 8), nrow = 4, ncol = 8)
mat2 <- matrix(rnorm(n = 8 * 3), nrow = 8, ncol = 3)

# Matrix Multiply
mat1 \%*\% mat2
einsum("ij,jk -> ik", mat1, mat2)

# einsum_generator() works just like einsum() but returns a performant function
mat_mult <- einsum_generator("ij,jk -> ik")
mat_mult(mat1, mat2)

# Diag
mat_sq <- matrix(rnorm(n = 4 * 4), nrow = 4, ncol = 4)
diag(mat_sq)
einsum("ii->i", mat_sq)
einsum("ii->ii", mat_sq)

# Trace
sum(diag(mat_sq))
einsum("ii->", mat_sq)


# Scalar product
mat3 <- matrix(rnorm(n = 4 * 8), nrow = 4, ncol = 8)
mat3 * mat1
einsum("ij,ij->ij", mat3, mat1)

# Transpose
t(mat1)
einsum("ij->ji", mat1)


# Batched L2 norm
arr1 <- array(c(mat1, mat3), dim = c(dim(mat1), 2))
c(sum(mat1^2), sum(mat3^2))
einsum("ijb,ijb->b", arr1, arr1)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/einsum-package.R
\docType{package}
\name{einsum_package}
\alias{einsum_package}
\alias{einsum-package}
\title{Einstein Summation}
\description{
Einstein summation is a concise mathematical notation that
implicitly sums over repeated indices of n-dimensional arrays. Many ordinary
matrix operations (e.g. transpose, matrix multiplication, scalar product, 'diag()', trace etc.)
can be written using Einstein notation. The notation is particularly convenient for
expressing operations on arrays with more than two dimensions because the
respective operators ('tensor products') might not have a standardized name.
}
